<?php
if (!defined("WHMCS")) {
	die("This file cannot be accessed directly");
}

use \WHMCS\Database\Capsule as Capsule;

function whmcsfaka_config()
{
	return array(
		'name' => '发卡管理',
		'description' => 'WHMCS发卡管理插件(修复版)',
		'author' => 'WHMCS',
		'version' => '2.7',
	);
}

function whmcsfaka_activate()
{
	$query = "CREATE TABLE IF NOT EXISTS `mod_whmcsfaka` ( `id` int(255) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT '主键', `cardkey` LONGTEXT NOT NULL COMMENT '卡密内容', `status` varchar(500) NOT NULL COMMENT '卡密状态', `user` varchar(500) DEFAULT NULL COMMENT '使用用户', `bz` LONGTEXT DEFAULT NULL COMMENT '备注', `type` varchar(500) DEFAULT NULL COMMENT '卡密type', `addtime` datetime COMMENT '添加/修改时间', `usetime` datetime COMMENT '销售时间', `shelflife` int(12) COMMENT '质保期', `serviceid` int(12) COMMENT '服务号', PRIMARY KEY (`id`) ) ENGINE = InnoDB CHARSET = utf8 AUTO_INCREMENT = 0 COMMENT 'whmcsfaka插件表';";
	full_query($query);
	return array('status' => 'success', 'description' => '插件已经成功激活,请设置插件');
}

function whmcsfaka_deactivate()
{
	try {
		Capsule::schema()->dropIfExists("mod_whmcsfaka");
		return array("status" => "success", "description" => "模块卸载成功");
	} catch (Exception $e) {
		return array("status" => "error", "description" => "Unable to drop tables : " . $e->getMessage());
	}
}

function whmcsfaka_upgrade($vars)
{
	$currentlyInstalledVersion = $vars['version'];
	if ($currentlyInstalledVersion <= '1.2') {
		$query = "ALTER TABLE `mod_whmcsfaka` ADD `bz` TEXT DEFAULT NULL AFTER `type`;";
		full_query($query);
	} elseif ($currentlyInstalledVersion == '2.0') {
		$query = "ALTER TABLE `mod_whmcsfaka` CHANGE `cardkey` `cardkey` LONGTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '卡密内容';";
		full_query($query);
		$queryo = "ALTER TABLE `mod_whmcsfaka` CHANGE `bz` `bz` LONGTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注';";
		full_query($queryo);
	}
}

function whmcsfaka_output($vars)
{
	if ($_REQUEST['action'] == 'delete_kami') {
		if (@$_REQUEST['ajax'] != 'true') {
			exit('禁止直接访问');
		}
		if (!@$_REQUEST['kamisid']) {
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '参数不全';
			exit(json_encode($Infoarray));
		}
		$InfoFind = Capsule::table('mod_whmcsfaka')->where('id', $_REQUEST['kamisid'])->first();
		if (empty($InfoFind)) {
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '无法在数据库中找到该记录';
		} else {
			$InfoRm = Capsule::table('mod_whmcsfaka')->where('id', $_REQUEST['kamisid'])->delete();
			if (!$InfoRm) {
				$Infoarray['result'] = 'error';
				$Infoarray['error'] = '未知错误';
			} else {
				$Infoarray['result'] = 'success';
			}
		}
		header('Content-Type: text/json; charset=utf-8');
		exit(json_encode($Infoarray));
	} elseif ($_REQUEST['action'] == 'get_kami_list') {
		if (@$_REQUEST['ajax'] != 'true') {
			exit('禁止直接访问');
		}
		$kamilist = Capsule::table('mod_whmcsfaka')->get();
		$kamilistarray = array();
		$num = 0;
		foreach ($kamilist as $values) {
			$kamilistarray[$num]['id'] = $values->id;
			$kamilistarray[$num]['cardkey'] = nl2br($values->cardkey);
			$kamilistarray[$num]['type'] = $values->type;
			$kamilistarray[$num]['addtime'] = $values->addtime;
			$kamilistarray[$num]['shelflife'] = $values->shelflife;
			if (!$values->usetime) {
				$kamilistarray[$num]['usetime'] = '未销售';
			} else {
				$kamilistarray[$num]['usetime'] = $values->usetime;
			}
			if (!$values->user) {
				$kamilistarray[$num]['user'] = '无';
			} else {
				$kamilistarray[$num]['user'] = '<a href="/admin/clientssummary.php?userid=' . $values->user . '" target="_blank">' . $values->user . '</a>';
			}
			if (!$values->bz) {
				$kamilistarray[$num]['bz'] = '无';
			} else {
				$kamilistarray[$num]['bz'] = $values->bz;
			}
			if ($values->status == 'ok') {
				$kamilistarray[$num]['status'] = '未销售';
			} elseif ($values->status == 'use') {
				$kamilistarray[$num]['status'] = '已使用';
			} else {
				$kamilistarray[$num]['status'] = '未知状态';
			}
			$keyformatdata = explode("<br />", nl2br($values->cardkey));
			if (@$keyformatdata[1]) {
				$values->cardkey = str_replace(array("\r", "\n", "\r\n"), '\n', $values->cardkey);
				$kamilistarray[$num]['action'] = '<td><a class="btn btn-danger btn-xs" href="javascript:void(0)" onclick="delete_kami(' . $values->id . ')">删除卡密</a></td>' . "   <a class=\"btn btn-primary btn-xs\" href=\"javascript:void(0)\" onclick=\"edit_kami_mline('$values->cardkey','$values->type','$values->shelflife',$values->id,'$values->bz')\">修改卡密</a></td>";
			} else {
				$kamilistarray[$num]['action'] = '<td><a class="btn btn-danger btn-xs" href="javascript:void(0)" onclick="delete_kami(' . $values->id . ')">删除卡密</a></td>' . "   <a class=\"btn btn-primary btn-xs\" href=\"javascript:void(0)\" onclick=\"edit_kami('$values->cardkey','$values->type','$values->shelflife',$values->id,'$values->bz')\">修改卡密</a></td>";
			}
			$num++;
		}
		$Infoarray['result'] = 'success';
		$Infoarray['kami'] = $kamilistarray;
		header('Content-Type: text/json; charset=utf-8');
		exit(json_encode($Infoarray));
	} elseif ($_REQUEST['action'] == 'add_kami') {
		if (@$_REQUEST['ajax'] != 'true') {
			exit('禁止直接访问');
		}
		if (!@$_REQUEST['cardkey'] || !@$_REQUEST['cardtype'] || !@$_REQUEST['cardshelflife']) {
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '参数不全';
			exit(json_encode($Infoarray));
		}
		$text = nl2br($_REQUEST['cardkey']);
		$textArr = explode("<br />", $text);
		foreach ($textArr as $val) {
			//去重
			$InfoFind = Capsule::table('mod_whmcsfaka')->where('cardkey', trim($val))->where('type', $_REQUEST['cardtype'])->first();
			if ($InfoFind) {
				continue;
			}
			$InfoAdd = Capsule::table('mod_whmcsfaka')->insert(array('cardkey' => trim($val), 'status' => 'ok', 'type' => $_REQUEST['cardtype'], 'bz' => $_REQUEST['cardbz'], 'addtime' => new DateTime(), 'shelflife' => $_REQUEST['cardshelflife'],));
			if (!$InfoAdd) {
				$Infoarray['result'] = 'error';
				$Infoarray['error'] = '卡密无法插入数据库';
				exit(json_encode($Infoarray));
			}
		}
		$Infoarray['result'] = 'success';
		exit(json_encode($Infoarray));
	} elseif ($_REQUEST['action'] == 'down_kami') {
		if (!@$_REQUEST['cardstatus'] || !@$_REQUEST['cardtype']) {
			exit('参数不全');
		}
		if ($_REQUEST['cardstatus'] == 'onlyuse') {
			$infolist = Capsule::table('mod_whmcsfaka')->where('status', 'use')->where('type', trim($_REQUEST['cardtype']))->get();
			$InfoTxt = '';
			foreach ($infolist as $values) {
				$InfoTxt .= $values->cardkey . "\r\n";
			}
		} elseif ($_REQUEST['cardstatus'] == 'onlynouse') {
			$infolist = Capsule::table('mod_whmcsfaka')->where('status', 'ok')->where('type', trim($_REQUEST['cardtype']))->get();
			$InfoTxt = '';
			foreach ($infolist as $values) {
				$InfoTxt .= $values->cardkey . "\r\n";
			}
		} elseif ($_REQUEST['cardstatus'] == 'allinfo') {
			$infolist = Capsule::table('mod_whmcsfaka')->where('type', trim($_REQUEST['cardtype']))->get();
			$InfoTxt = '';
			foreach ($infolist as $values) {
				if (!$values->bz) {
					$kmbz = '无备注';
				} else {
					$kmbz = $values->bz;
				}
				if (!$values->usetime) {
					$usetime = '未销售';
				}
				if (!$values->user) {
					$kmuser = '无';
				} else {
					$kmuser = $values->user;
				}
				if ($values->status == 'ok') {
					$kmstatus = '未销售';
				} elseif ($values->status == 'use') {
					$kmstatus = '已使用';
				} else {
					$kmstatus = $values->status;
				}
				$InfoTxt .= '卡密内容:' . $values->cardkey . '卡密类别:' . $values->type . '卡密备注:' . $kmbz . '质保期:' . $values->shelflife . '添加/修改时间:' . $values->addtime . '卡密状态:' . $kmstatus . '销售时间:' . $usetime . '用户ID:' . $kmuser . "\r\n";
			}
		} elseif ($_REQUEST['cardstatus'] == 'useallinfo') {
			$infolist = Capsule::table('mod_whmcsfaka')->where('status', 'use')->where('type', trim($_REQUEST['cardtype']))->get();
			$InfoTxt = '';
			foreach ($infolist as $values) {
				if (!$values->bz) {
					$kmbz = '无备注';
				} else {
					$kmbz = $values->bz;
				}
				if (!$values->user) {
					$kmuser = '无';
				} else {
					$kmuser = $values->user;
				}
				if (!$values->usetime) {
					$usetime = '未销售';
				}
				$InfoTxt .= '卡密内容:' . $values->cardkey . '卡密类别:' . $values->type . '卡密备注:' . $kmbz . '质保期:' . $values->shelflife . '添加/修改时间:' . $values->addtime . '卡密状态:已使用' . '销售时间:' . $usetime . '用户ID:' . $kmuser . "\r\n";
			}
		} elseif ($_REQUEST['cardstatus'] == 'all') {
			$infolist = Capsule::table('mod_whmcsfaka')->where('type', trim($_REQUEST['cardtype']))->get();
			$InfoTxt = '';
			foreach ($infolist as $values) {
				$InfoTxt .= $values->cardkey . "\r\n";
			}
		} else {
			exit('参数不全');
		}
		if (!$InfoTxt) {
			exit('数据库中没有符合条件的记录');
		}
		header('Content-Description: File Transfer');
		header('Content-Type: application/octet-stream');
		header('Content-Disposition: attachment; filename=kami_list.txt');
		echo $InfoTxt;
		exit();
	} elseif ($_REQUEST['action'] == 'add_kami_mline') {
		if (@$_REQUEST['ajax'] != 'true') {
			exit('禁止直接访问');
		}
		if (!@$_REQUEST['cardkey'] || !@$_REQUEST['cardtype'] || !@$_REQUEST['cardshelflife']) {
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '参数不全';
			exit(json_encode($Infoarray));
		}
		$InfoFind = Capsule::table('mod_whmcsfaka')->where('cardkey', trim($_REQUEST['cardkey']))->where('type', $_REQUEST['cardtype'])->first();
		if ($InfoFind) {
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '卡密已存在于数据库';
			exit(json_encode($Infoarray));
		}
		$InfoAdd = Capsule::table('mod_whmcsfaka')->insert(array('cardkey' => trim($_REQUEST['cardkey']), 'status' => 'ok', 'type' => $_REQUEST['cardtype'], 'bz' => $_REQUEST['cardbz'], 'addtime' => new DateTime(), 'shelflife' => $_REQUEST['cardshelflife']));
		if (!$InfoAdd) {
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '卡密无法插入数据库';
			exit(json_encode($Infoarray));
		}
		$Infoarray['result'] = 'success';
		exit(json_encode($Infoarray));
	} elseif ($_REQUEST['action'] == 'edit_kami') {
		if (@$_REQUEST['ajax'] != 'true') {
			exit('禁止直接访问');
		}
		if (!@$_REQUEST['cardkey'] || !@$_REQUEST['cardtype'] || !@$_REQUEST['cardshelflife'] || !@$_REQUEST['cardid']) {
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '参数不全';
			exit(json_encode($Infoarray));
		}
		$InfoFind = Capsule::table('mod_whmcsfaka')->where('id', trim($_REQUEST['cardid']))->first();
		if (!$InfoFind) {
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '记录不存在';
			exit(json_encode($Infoarray));
		}
		$InfoUpdate = Capsule::table('mod_whmcsfaka')->where('id', trim($_REQUEST['cardid']))->update(array('cardkey' => trim($_REQUEST['cardkey']), 'type' => $_REQUEST['cardtype'], 'bz' => $_REQUEST['cardbz'], 'addtime' => new DateTime(), 'shelflife' => $_REQUEST['cardshelflife']));
		if (!$InfoUpdate) {
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '无法插入数据库';
			exit(json_encode($Infoarray));
		} else {
			$Infoarray['result'] = 'success';
			exit(json_encode($Infoarray));
		}
	} elseif ($_REQUEST['action'] == 'edit_kami_mline') {
		if (@$_REQUEST['ajax'] != 'true') {
			exit('禁止直接访问');
		}
		if (!@$_REQUEST['cardkey'] || !@$_REQUEST['cardtype'] || !@$_REQUEST['cardshelflife'] || !@$_REQUEST['cardid']) {
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '参数不全';
			exit(json_encode($Infoarray));
		}
		$InfoFind = Capsule::table('mod_whmcsfaka')->where('id', trim($_REQUEST['cardid']))->first();
		if (!$InfoFind) {
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '记录不存在';
			exit(json_encode($Infoarray));
		}
		$InfoUpdate = Capsule::table('mod_whmcsfaka')->where('id', trim($_REQUEST['cardid']))->update(array('cardkey' => trim($_REQUEST['cardkey']), 'type' => $_REQUEST['cardtype'], 'bz' => $_REQUEST['cardbz'], 'addtime' => new DateTime(), 'shelflife' => $_REQUEST['cardshelflife']));
		if (!$InfoUpdate) {
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '无法插入数据库';
			exit(json_encode($Infoarray));
		} else {
			$Infoarray['result'] = 'success';
			exit(json_encode($Infoarray));
		}
	} elseif ($_REQUEST['action'] == 'gen_kami') {
		if (@$_REQUEST['ajax'] != 'true') {
			exit('禁止直接访问');
		}
		if (!@$_REQUEST['cardstart'] || !@$_REQUEST['cardlen'] || !@$_REQUEST['cardnum'] || !@$_REQUEST['cardtype'] || !is_numeric($_REQUEST['cardlen']) || !is_numeric($_REQUEST['cardnum'])) {
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '参数不全或值错误';
			exit(json_encode($Infoarray));
		}
		$CardStart = trim($_REQUEST['cardstart']);
		$CardNum = $_REQUEST['cardnum'];
		$CardLen = $_REQUEST['cardlen'] - strlen($CardStart);
		for ($x = 0; $x < $CardNum; $x++) {
			$CardKey = $CardStart . fakagrs($CardLen);
			//FIXME 去重
			$InfoFind = Capsule::table('mod_whmcsfaka')->where('cardkey', $CardKey)->where('type', $_REQUEST['cardtype'])->first();
			if ($InfoFind) {
				$x--;
				continue;
			}
			$InfoAdd = Capsule::table('mod_whmcsfaka')->insert(array('cardkey' => $CardKey, 'status' => 'ok', 'type' => $_REQUEST['cardtype'], 'bz' => $_REQUEST['cardbz'], 'addtime' => new DateTime(), 'shelflife' => $_REQUEST['cardshelflife']));
			if (!$InfoAdd) {
				$Infoarray['result'] = 'error';
				$Infoarray['error'] = '生成第' . $x . '个卡密时无法插入数据库';
				exit(json_encode($Infoarray));
			}
		}
		$Infoarray['result'] = 'success';
		exit(json_encode($Infoarray));
	} else {
		include 'templates.admin.php';
		if (@$_REQUEST['ajax'] != 'true') {
			echo $Header . PHP_EOL . $kami_management . PHP_EOL . $Footer . PHP_EOL;
		} else {
			exit($kami_management . PHP_EOL);
		}
	}
}

function fakagrs($len, $chars = null)
{
	if (is_null($chars)) {
		$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
	}
	for ($i = 0, $str = '', $lc = strlen($chars) - 1; $i < $len; $i++) {
		$str .= $chars[random_int(0, $lc)];
	}
	return $str;
}
