<?php

if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}

use Illuminate\Database\Capsule\Manager as Capsule;

function whmcsfaka_MetaData()
{
    return array(
        'DisplayName' => 'whmcsfaka',
        'APIVersion' => '1.1',
        'RequiresServer' => false,
    );
}

function whmcsfaka_ConfigOptions()
{
    return array(
        '卡密类别' => array(
            'Type' => 'text',
            'Size' => '500',
            'Default' => '1',
        ),
        '允许补单次数' => array(
            'Type' => 'text',
            'Size' => '500',
            'Default' => '1',
        ),
        '通知消息' => array(
            'Type' => 'textarea', 
            'Rows' => '3', 
            'Cols' => '50', 
            'Description' => "展示给客户的通知消息"
            )
    );
}

function whmcsfaka_AdminCustomButtonArray()
{
    return array(
        "补单" => 'CreateAccountNew'
    );
}

function whmcsfaka_ClientAreaCustomButtonArray() {
    return array(
        "翻车补单"   => "ApplyForNew"
    );
}

function whmcsfaka_CreateAccount(array $params)
{
    try {
        $KamiFindAvailableNo = Capsule::table('mod_whmcsfaka')->where('type', $params['configoption1'])->where('status', 'ok')->count();
        $NumberOfPurchases = Capsule::table('tblhosting')->where('id', $params['serviceid'])->first()->qty;
        if ($KamiFindAvailableNo < $NumberOfPurchases) {
            throw new Exception('无法提取卡密，可用卡密不够');
        }
        $kamiids = "";
        for ($i = 1;; $i++) {
            if ($i > $NumberOfPurchases) {
                break;
            }
            $KamiFind = Capsule::table('mod_whmcsfaka')->where('type', $params['configoption1'])->where('status', 'ok')->first();
            $InfoUpdate = Capsule::table('mod_whmcsfaka')->where('cardkey', $KamiFind->cardkey)->update(array('status' => 'use', 'user' => $params['clientsdetails']['userid'], 'usetime' => new DateTime(), 'serviceid' => $params['serviceid'])); //将用户写入发卡数据表
            if (!$InfoUpdate) {
                throw new Exception('开通失败无法插入数据库');
            }
            $temp =  $KamiFind->id . " ";
            $kamiids .=  $temp;
        }
        Capsule::table('tblhosting')->where('id', $params['serviceid'])->update(['username' => base64_encode(json_encode($kamiids))]); //将数据写入whmcs的hosting表
        Capsule::table('tblhosting')->where('id', $params['serviceid'])->update(['password' => "0"]); //已经补单次数
        return 'success';
    } catch (Exception $e) {
        logModuleCall(
            'whmcsfaka',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
}

function whmcsfaka_TerminateAccount(array $params)
{
    try {
        Capsule::table('mod_whmcsfaka')->where('serviceid', $params['serviceid'])->delete();
        return 'success';
    } catch (Exception $e) {
        return $e->getMessage();
    }
}

function whmcsfaka_ClientArea(array $params)
{
    try {
        $kamiids = json_decode(base64_decode($params['username']), true);
        $kamiid = explode(" ", $kamiids);
        $cardkey = "";
        foreach ($kamiid as $kamiidforeach) {
            if ($kamiidforeach) {
                $KamiFind = Capsule::table('mod_whmcsfaka')->where('id', $kamiidforeach)->first();
                $temp = nl2br($KamiFind->cardkey)."<br>";
                $cardkey .=  $temp;
                $templatevar['cardtype'] = $KamiFind->type;
                $templatevar['shelflife'] = $KamiFind->shelflife;
            }
        }
        $templatevar['cardkey'] = $cardkey;
        $templatevar['announcements'] = Capsule::table('tblproducts')->where('id', $params['pid'])->first()->configoption3;
        if (!$templatevar['cardkey']) {
            $templatevar['cardkey'] = '不可用';
        }
        if (!$templatevar['cardtype']) {
            $templatevar['cardtype'] = '不可用';
        }
        if ($KamiFind->bz) {
            $templatevar['cardbz'] = $KamiFind->bz;
        } else {
            $templatevar['cardbz'] = '无备注';
        }
        return array(
            'tabOverviewReplacementTemplate' => 'templates/overview.tpl',
            'templateVariables' => $templatevar,
        );
    } catch (Exception $e) {
        logModuleCall(
            'whmcsfaka',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return array(
            'tabOverviewReplacementTemplate' => 'templates/error.tpl',
            'templateVariables' => array(
                'ErrorInfo' => $e->getMessage(),
            ),
        );
    }
}


function whmcsfaka_CreateAccountNew(array $params)
{
    try {
        $budantimes = Capsule::table('tblhosting')->where('id', $params['serviceid'])->first()->password;
        if ($budantimes < $params['configoption2']) {
        Capsule::table('mod_whmcsfaka')->where('serviceid', $params['serviceid'])->delete();
        $KamiFindAvailableNo = Capsule::table('mod_whmcsfaka')->where('type', $params['configoption1'])->where('status', 'ok')->count();
        $NumberOfPurchases = Capsule::table('tblhosting')->where('id', $params['serviceid'])->first()->qty;
        if ($KamiFindAvailableNo < $NumberOfPurchases) {
            throw new Exception('无法提取卡密，可用卡密不够');
        }
        $kamiids = "";
        for ($i = 1;; $i++) {
            if ($i > $NumberOfPurchases) {
                break;
            }
            $KamiFind = Capsule::table('mod_whmcsfaka')->where('type', $params['configoption1'])->where('status', 'ok')->first();
            $InfoUpdate = Capsule::table('mod_whmcsfaka')->where('cardkey', $KamiFind->cardkey)->update(array('status' => 'use', 'user' => $params['clientsdetails']['userid'], 'usetime' => new DateTime(), 'serviceid' => $params['serviceid'])); //将用户写入发卡数据表
            if (!$InfoUpdate) {
                throw new Exception('开通失败无法插入数据库');
            }
            $temp =  $KamiFind->id . " ";
            $kamiids .=  $temp;
        }
        Capsule::table('tblhosting')->where('id', $params['serviceid'])->update(['username' => base64_encode(json_encode($kamiids))]); //将数据写入whmcs的hosting表
        Capsule::table('tblhosting')->where('id', $params['serviceid'])->update(['password' => 'password'+1]); //补单次数
        return 'success';
        } else {
                throw new Exception('补单已经达到最大次数');    
        }
    } catch (Exception $e) {
        logModuleCall(
            'whmcsfaka',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
}

function whmcsfaka_AdminServicesTabFields(array $params){
    try{
    $kamiids = json_decode(base64_decode($params['username']), true);
    $kamiid = explode(" ", $kamiids);
    $cardkey = "";
    foreach ($kamiid as $kamiidforeach) {
        if ($kamiidforeach) {
            $KamiFind = Capsule::table('mod_whmcsfaka')->where('id', $kamiidforeach)->first();
            $temp = nl2br($KamiFind->cardkey). "<br>";
            $cardkey .=  $temp;
        }
    }
    $templatevar['announcements'] = Capsule::table('tblproducts')->where('id', $params['pid'])->first()->configoption3;
    if (!$templatevar['cardkey']) {
            $templatevar['cardkey'] = '不可用';
    }
    if (!$templatevar['cardtype']) {
            $templatevar['cardtype'] = '不可用';
    }
    if ($KamiFind->bz) {
            $templatevar['cardbz'] = $KamiFind->bz;
    } else {
            $templatevar['cardbz'] = '无备注';
    }
    $templatevar['cardkey'] = $cardkey;
    return array(
        "卡密类型"  => $templatevar['cardtype'],
        "卡密备注"  => $templatevar['cardbz'],
        "卡密内容"  => $templatevar['cardkey'],
        );
    } catch (Exception $e) {
        logModuleCall('whmcsfaka', 'whmcsfaka_AdminServicesTabFields', $params, $e->getMessage(), $e->getTraceAsString());
        return $e->getTraceAsString();
    }
    
}

function whmcsfaka_ApplyForNew(array $params) {
    try {
    $timenow = time();
    $kamiids = json_decode(base64_decode($params['username']), true);
    $kamiid = explode(" ", $kamiids);
    $cardkey = "";
    foreach ($kamiid as $kamiidforeach) {
        if ($kamiidforeach) {
            $KamiFind = Capsule::table('mod_whmcsfaka')->where('id', $kamiidforeach)->first();
            $temp = nl2br($KamiFind->cardkey). PHP_EOL;
            $cardkey .=  $temp;
        }
    }
    $userProduct = Capsule::table('mod_whmcsfaka')->where('user', $params['userid'])->where('serviceid', $params['serviceid'])->first();
    $TimeOfSale = $userProduct->usetime;
    $ShelfLife = $userProduct->shelflife;
    $TimeDiff=round(($timenow-strtotime($TimeOfSale))/86400);
    if ($TimeDiff > $ShelfLife) {
        return "质保期已过,无法申请补单";
    } else {
         $getadmin = Capsule::table("tbladmins")->first();
         $adminusername = $getadmin->firstname . " " . $getadmin->lastname;
         $command = 'OpenTicket';
         $postData = array(
                     'deptid' => '1',
                     'subject' => '卡密产品补单申请',
                     'message' => '该产品已确认出现问题,特申请补单,请审核
                     ' . PHP_EOL . $cardkey,
                     'clientid' => $params['userid'],
                     'priority' => 'Medium',
                     'markdown' => true,
                     'serviceid' => $params['serviceid'],
            );
          $results = localAPI($command, $postData, $adminUsername);
        return "success";
    }
    } catch (Exception $e) {
        logModuleCall(
            'provisioningmodule',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );

        return $e->getMessage();
    }
    
    
}